/* * * * * * * * * * * * * * * * * * *
 *            bergen.cpp        *
 * * * * * * * * * * * * * * * * * * */
#include <cave_ogl.h>
#include <iostream>
#include "bergenServer.h"
#include "bergenSample.h"

void frameFunc();
void DrawGLScene();
void InitGL();

bergenServer *bserver;
bergenSample *sound=0;

int main(int argc, char **argv) 
{  
   int end=0;
   std::cout<< "Creating sound server" << std::endl;
   if (argc >  1) bserver=new bergenServer(argv[1]);
   else bserver=new bergenServer();
//   for (;;) {
  		std::cout << "Starting application" << std::endl;
		CAVEConfigure(&argc,argv,NULL);
  		std::cout << "App configured, setting up callbacks" << std::endl;
		if (!end) {
			CAVEInitApplication((CAVECALLBACK)InitGL,0);
	  		std::cout << "InitApp in place" << std::endl;		
			CAVEDisplay((CAVECALLBACK)DrawGLScene,0);
  			std::cout << "Display in place" << std::endl;		
			CAVEFrameFunction((CAVECALLBACK)frameFunc,0);
	  		std::cout << "Callbacks set up, calling Init;" << std::endl;
		} else {
			std::cout << "Setting callbacks up skipped" << std::endl;
		}
		CAVEInit();
   	std::cout << "Opening DistribConnection " << std::endl;
	   CAVEDistribOpenConnection(1);
   	CAVEDistribOpenConnection(2);
    	
		std::cout << "Starting up main loop" << std::endl;	
 		if (CAVEDistribMaster()) 
			while (!end) {
				CAVEUSleep(10);
				if (CAVEgetbutton(CAVE_ESCKEY)) {end=1;std::cout<<"ESC"<<std::endl;}
				if (CAVEgetbutton(CAVE_RKEY)) {end=2;std::cout<<"RKEY"<<std::endl;}
			}
		else while (!CAVESync->Quit) CAVEUSleep(15);
//		CAVEDistribBarrier(1);
	    if (CAVEDistribMaster()) {
			std::cout<<"Sending msg to slaves"<<std::endl;
			CAVEDistribWrite(2,(void*)&end,sizeof(int));
			std::cout<<"Msg sent."<<std::endl;
	    } else {
			std::cout<<"Receiving msg"<<std::endl;
			CAVEDistribRead(2,(void*)&end,sizeof(int));
			std::cout<<"Msg: "<<end<<std::endl;
	    }
//		CAVEDistribCloseConnection(1);
//		CAVEDistribCloseConnection(2);						
		switch	 (end) {
			case 0:	std::cout << "Something awful happened, gonna end it up." << std::endl;
			case 1:	std::cout << "Cleaning up." << std::endl;
						CAVEExit();
						break;
			case 2:	std::cout << "Request for app restart caught, trying to restart" << std::endl;
						CAVEHalt();
						return (2);
		}
		
//	}
//	return 0;
}

void frameFunc()
{
  if (CAVEDistribMaster()) {
//  	std::cout<<"mastaaa"<<std::endl;
//	std::cout<<CAVEGetFrameNumber() << std::endl;
	if (!(CAVEGetFrameNumber()%1000) && bserver->connected() /*&& !sound*/) {
		if (sound) {
			if (sound->isPlaying()) {
				sound->stop();
			}
			delete sound;
			sound = 0;
		}
		sound=new bergenSample ("/usr/local/bergen/bin/gong.aiff",bserver);
		sound->play();
	}
	static float prevtime = 0;
	float t = CAVEGetTime();
	float dt = t - prevtime;
	prevtime=t;
	float jx = CAVE_JOYSTICK_X;
	float jy = CAVE_JOYSTICK_Y;
	float _speed_ = 5.0f;
	if (fabs(jy)>0.2) {
	float wand[3];
	CAVEGetVector(CAVE_WAND_FRONT,wand);
	CAVENavTranslate(wand[0]*jy*dt*_speed_,
			wand[1]*jy*dt*_speed_,
			wand[2]*jy*dt*_speed_);
	}
	if (fabs(jx) > 0.2) {
	CAVENavRot(-jx*90*dt,'y');
	}
	CAVEDisplayBarrier();
	}
	
	
//  }
}

void InitGL()
{
	std::cout << "OpenGL initialization starting" << std::endl;
	glClearColor(.0f, .0f, .0f, .0f);
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
	std::cout << "OpenGL initialization finished" << std::endl;
}

void DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	CAVENavTransform();
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);	



	glBegin(GL_TRIANGLES);
		glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
		glVertex3f(-1.0f,  4.0f,  -5.0f);
		glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
		glVertex3f( 1.0f, 5.0f,  -5.0f);
		glColor4f(0.0f, 0.0f, 1.0f, 0.0f); 
		glVertex3f( 1.0f,  3.0f,  -5.0f);
	glEnd();

}
