/* * * * * * * * * * * * * * * * * * *
 *            intercave.cpp         *
 * * * * * * * * * * * * * * * * * * */
#include <cave_ogl.h>
#include <iostream>
#include <GL/glut.h>
#include <map>

void frameFunc();
void DrawGLScene();
void InitGL();
void netAdduser(CAVE_USER_ST *user,void *appdata);
void netDeluser(CAVE_USER_ST *user,void *appdata);
void netdata(CAVE_USER_ST *user,void *buffer,size_t size, void *app);
char *typeOfProcess();
float x=0.0f,y=4.0f,z=-5.0f;
struct user_data {
	char magic;
	user_data(float x=0.0f,float y=4.0f, float z=-5.0f):magic(37),x(x),y(y),z(z) {}
	user_data(user_data *data):magic(37),x(data->x),y(data->y),z(data->z) {}
	float x,y,z;
} *my_data;
std::map<CAVE_USER_ST*,user_data*> users;
int main(int argc, char **argv) 
{  
   int end=0;
   my_data=new user_data();
//   std::cout << sizeof(user_data) << std::endl;
	std::cout << "Starting application" << std::endl;
//	CAVESetOption(CAVE_DIST_NETWORKSLAVE,1);
	CAVEConfigure(&argc,argv,NULL);
	std::cout << "App configured, setting up callbacks" << std::endl;
	if (!end) {
		CAVEInitApplication((CAVECALLBACK)InitGL,0);
  		std::cout << "InitApp in place" << std::endl;		
		CAVEDisplay((CAVECALLBACK)DrawGLScene,0);
		std::cout << "Display in place" << std::endl;		
		CAVEFrameFunction((CAVECALLBACK)frameFunc,0);
		std::cout << "FrameFunc in place" << std::endl;		
		CAVEAddCallback(CAVE_NETAPPDATA_CALLBACK,(CAVECALLBACK)netdata,0);		
		CAVEAddCallback(CAVE_NETADDUSER_CALLBACK,(CAVECALLBACK)netAdduser,0);
		CAVEAddCallback(CAVE_NETDELETEUSER_CALLBACK,(CAVECALLBACK)netDeluser,0);
  		std::cout << "Callbacks set up, calling Init;" << std::endl;
	} else {
		std::cout << "Setting callbacks up skipped" << std::endl;
	}
	CAVEInit();
//  	std::cout << "Opening DistribConnection " << std::endl;
//	CAVEDistribOpenConnection(1);
// 	CAVEDistribOpenConnection(2);
   	
	std::cout << "Starting up main loop" << std::endl;	
	if (CAVEDistribMaster()) 
		while (!end) {
			CAVEUSleep(10);
			if (CAVEgetbutton(CAVE_ESCKEY)) {end=1;std::cout<<"ESC"<<std::endl;}
//			if (CAVEgetbutton(CAVE_F5KEY)) {end=2;std::cout<<"RKEY"<<std::endl;}
//			std::cout << CAVENumUsers << "/" << CAVEptr->numUsers << "(" << typeOfProcess() << ")" << std::endl;			
		}
	else while (!CAVESync->Quit) CAVEUSleep(15);
/*    if (CAVEDistribMaster()) {
		std::cout<<"Sending msg to slaves"<<std::endl;
		CAVEDistribWrite(2,(void*)&end,sizeof(int));
		std::cout<<"Msg sent."<<std::endl;
    } else {
		std::cout<<"Receiving msg"<<std::endl;
		CAVEDistribRead(2,(void*)&end,sizeof(int));
		std::cout<<"Msg: "<<end<<std::endl;
    }
	CAVEDistribCloseConnection(1);						    
	CAVEDistribCloseConnection(2);						
	switch	 (end) {
		case 0:	std::cout << "Something awful happened, gonna end it up." << std::endl;
		case 1:	std::cout << "Cleaning up." << std::endl;
					CAVEExit();
					break;
		case 2:	std::cout << "Request for app restart caught, trying to restart" << std::endl;
					CAVEHalt();
					return (2);
	}*/
}

void frameFunc()
{
  if (CAVEDistribMaster()) {
	static float prevtime = 0;
	float t = CAVEGetTime();
	float dt = t - prevtime;
	prevtime=t;
	float jx = CAVE_JOYSTICK_X;
	float jy = CAVE_JOYSTICK_Y;
	float _speed_ = 5.0f;
	bool pot_moved=false;
	if (fabs(jy)>0.2) {
		float wand[3];
		CAVEGetVector(CAVE_WAND_FRONT,wand);
		CAVENavTranslate(wand[0]*jy*dt*_speed_,
			wand[1]*jy*dt*_speed_,
			wand[2]*jy*dt*_speed_);
	}
	if (fabs(jx) > 0.2) {
	CAVENavRot(-jx*90*dt,'y');
	}
	if (CAVEgetbutton(CAVE_RKEY)) {
		my_data->x+=dt*+_speed_;
		pot_moved=true;
	}
	if (CAVEgetbutton(CAVE_LKEY)) {
		my_data->x-=dt*+_speed_;
		pot_moved=true;
	}
	if (CAVEgetbutton(CAVE_UKEY)) {
		my_data->y+=dt*+_speed_;
		pot_moved=true;
	}
	if (CAVEgetbutton(CAVE_DKEY)) {
		my_data->y-=dt*+_speed_;
		pot_moved=true;
	}
	if (pot_moved) {
		std::cout<<"sending data"<<std::endl;
		CAVENetSend(my_data,sizeof(user_data));
	}
	CAVEDisplayBarrier();
	}
}

void InitGL()
{
	std::cout << "OpenGL initialization starting" << std::endl;
	glClearColor(.0f, .0f, .0f, .0f);
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
	std::cout << "OpenGL initialization finished" << std::endl;
}

void DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	CAVENavTransform();
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);	
	
	
	glPushMatrix();
	glTranslatef(my_data->x,my_data->y,my_data->z);
	glutWireTeapot(1.0f);
	glPopMatrix();
	for (std::map<CAVE_USER_ST*,user_data*>::iterator i = users.begin();i!=users.end();++i) {
	volatile CAVE_USER_ST* user=(*i).first;
	user_data* data=(*i).second;
		if (user) {
			glPushMatrix();
			CAVENetHeadTransform(user);
			glutSolidSphere(2.0f, 10, 10);
			glPopMatrix();
			glPushMatrix();
			glTranslatef(data->x,data->y,data->z);
			glutWireTeapot(1.0f);
			glPopMatrix();		
		}		
	}

}
void netAdduser(CAVE_USER_ST *user,void *appdata)
{
	std::cout<< "New user(" << user->id << ") in CAVE!!!" <<std::endl;
	std::cout << CAVENumUsers << std::endl;
	std::cout << CAVEptr->numUsers << std::endl;
	std::cout << typeOfProcess() << std::endl;
	users[user]=new user_data;
	std::cout << "V users je: " << users.size()<< std::endl;
}

void netDeluser(CAVE_USER_ST *user,void *appdata)
{
	std::cout<< "User (" << user->id << ") deleted from CAVE!!!" <<std::endl;
	std::cout << CAVENumUsers << std::endl;
	std::cout << CAVEptr->numUsers << std::endl;
	users.erase(user);
	std::cout << "V users je: " << users.size()<< std::endl;
}

char *typeOfProcess()
{
	switch (CAVEProcessType()) {
		case CAVE_APP_PROCESS: return "Application process";	
		case CAVE_DISPLAY_PROCESS: return "Display process";
		case CAVE_TRACKER_PROCESS: return "Tracker process";
		case CAVE_NETWORK_PROCESS: return "Network process";
		case CAVE_DISTRIB_PROCESS: return "Distrib process";
		default: return "Unknown process";
	}
}
void netdata(CAVE_USER_ST *user,void *buffer,size_t size, void *app)
{
	std::cout << "Data came!" << std::endl;
	if (*((char*)buffer)==37) {
		std::cout << "User data magic!" << std::endl;
		if (users[user]) delete users[user];
		users[user]=new user_data((user_data*)buffer);
	}
}

